> For the complete documentation index, see [llms.txt](https://docs.bloxroute.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bloxroute.com/bsc/streams/working-with-streams/cancelling-a-subscription.md).

# Cancelling a Subscription

This section provides step-by-step guides to canceling stream subscriptions using each supported protocol: Websocket and gRPC.

Websocket

If you need to cancel a subscription, pass the subscription ID to the **`unsubscribe`** call.

#### **Example**

{% tabs %}
{% tab title="Gateway" %}
Unsubscribe call example for the Gateway in Python (version 3.7 or higher):

```python
import asyncio, ssl, json, websockets

async def main():
    auth_key = "YOUR_AUTHORIZATION_HEADER"
    
    async with websockets.connect(
        'ws://127.0.0.1:28333/ws',
        header=["Authorization:{}".format(auth_key)],            
        sslopt={"cert_reqs": ssl.CERT_NONE},        
        ) as websocket:
            subscribe_request = {
                "jsonrpc": "2.0",
                "id": 1,
                "method": "subscribe",
                "params": ["newTxs", {"include": ["tx_hash"]}]
            }
            await websocket.send(json.dumps(subscribe_request))
            response = await websocket.recv()
            subscription_id = json.loads(response)["result"]
    
            unsubscribe_request = {
                "jsonrpc": "2.0",
                "id": 2,
                "method": "unsubscribe",
                "params": [subscription_id]
            }
            await websocket.send(json.dumps(unsubscribe_request))
            response = await websocket.recv()
            print("Unsubscribed successfully.")
    
if __name__ == '__main__':
    asyncio.run(main())
```

{% endtab %}

{% tab title="Cloud-API" %}
Unsubscribe call example for the Cloud-API in Python (version 3.7 or higher):

```python
import asyncio, ssl, json, websockets

async def main():
    auth_key = "YOUR_AUTHORIZATION_HEADER"
    
    async with websockets.connect(
        'wss://virginia.eth.blxrbdn.com/ws',
        header=["Authorization:{}".format(auth_key)],            
        sslopt={"cert_reqs": ssl.CERT_NONE},        
        ) as websocket:
            subscribe_request = {
                "jsonrpc": "2.0",
                "id": 1,
                "method": "subscribe",
                "params": ["newTxs", {"include": ["tx_hash"]}]
            }
            await websocket.send(json.dumps(subscribe_request))
            response = await websocket.recv()
            subscription_id = json.loads(response)["result"]
    
            unsubscribe_request = {
                "jsonrpc": "2.0",
                "id": 2,
                "method": "unsubscribe",
                "params": [subscription_id]
            }
            await websocket.send(json.dumps(unsubscribe_request))
            response = await websocket.recv()
    
            print("Unsubscribed successfully.")
    
if __name__ == '__main__':
    asyncio.run(main())
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.bloxroute.com/bsc/streams/working-with-streams/cancelling-a-subscription.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
